const path = require('path')
module.exports = class Url{
  // TODO: try making high-order function
  constructor(url) {
    this.urls = []
    if(typeof url === 'object'){
      if(Array.isArray(url)){
        this.urls = JSON.parse(JSON.stringify(url))
      }
      else this.urls = JSON.parse(JSON.stringify(url.getUrls()))
    }
  }
  join(string){ 
    let newUrls = JSON.parse(JSON.stringify(this.urls)) // Deep copy of this.urls
    newUrls.push(string)
    return newUrls
  }
  cd(){ // change directory to parent
    if(this.urls.length == 0)
      return []
    return this.urls.slice(0, this.urls.length-1)
  }
  toString(){
    let str = ''
    for(let url of this.urls){
      str += ('/'+url)
    }
    return str
  }
  getParent(){
    if(this.urls.length == 0)
      return new Url()
    return this.urls.slice(0, this.urls.length-1)
  }
  getPath(){
    path.resolve(this.resolve())
  }
  getUrls(){
    return this.urls
  }
  isEmpty(){
    return this.urls.length == 0
  }
}