## 자바스크립트 문서 목록

### 1. [Node.js](/kiwi/javascript/node)

### 2. Vue-wiki
#### 만들게 된 계기
Tistory, 네이버 블로그등은 Markdown을 제대로 지원해 주지 않는다.
Hexo, Jekyll등은 설정이 너무 복잡하다.
글 올리기는 귀찮은데 위키피디아 편집하는 식으로 깔짝깔짝 글을 추가할 수 있으면 좋을 것 같다!

#### 사용법
 - /kiwi 폴더 안에 제목.md의 마크다운 파일을 만들기
 - 날짜는 따로 기입할 필요 없이 자동으로 파일 생성/수정 날짜로 계산한다.
 - 하위 문서를 포함하는 폴더를 만들고 싶을때는 그대로 폴더를 만들고 폴더 안에 index.md를 두면 해당 index.md가 디렉토리의 메인 페이지가 된다.
 - `sudo npm run generate`
 - `dist` 폴더에 생성된 정적 페이지들을 Github Page에 업로드 한다.

#### TO-DO
 - **CLI 지원 + 이제 kiwi 폴더는 .gitignore에 추가** (진행중)
 - 프론트앤드에서 문서 추가 & 편집 기능 만들기
 - 커스텀 테마 지원하기
 - `kiwi` 폴더 watch 하기 -> utils.js 자동으로 실행해서 파일 디렉토리 트리 생성
 - 검색 기능 추가
 - `/kiwi`에서 최근에 수정된 문서, 최근에 생성된 문서 5개씩 보여주기
 - ESlint 적용 + Github에 프로젝트 소스코드 공개
 - 어떻게 하면 좀 더 편하게 배포할까?
 - 원클릭 Github Page 업로드 기능 만들기 (OAuth 2.0이용)
